*----------------------------------------------------------- 
* Program Title : My first 68k Assembly Program 
* Written by    : Neil Richardson 
* Date Created  : 1/11/05 
* Description   : 
*   Pong, hacked out of assembly in a few hours. 
*   This was wrote with the sole purpose of teaching 
*   me 68k assembler. I had no previous knowledge of 68k 
*   before starting this, only x86 assembly. 
*   It is not perfect, there are a few bugs as I taken 
*   shortcuts. Controls are 'A' & 'Z' for player 1, 
*   'K' & 'M' for player 2. 
*----------------------------------------------------------- 

   ORG   $800 

WHITE   EQU   $00FFFFFF 
GRAY   EQU   $00808080 
BLACK   EQU   $00000000 
RED   EQU   $000000FF 
BLUE   EQU   $00FF0000 
GREEN   EQU   $0000FF00 

START 

gameStart 
* Echo off 
   move.b   #12, D0 
   move.b   #0, D1 
   trap   #15 

* Ball shtuff 
   move.l   #320, ballX 
   move.l   #120, ballY 
   move.l   #3, deltaX 
   move.l   #3, deltaY 
   move.l   #8, ballSize 

* Paddle shtuff 
   move.l   #32, paddleSize 

* Paddle 0 
   move.l   #4, paddle0X 
   move.l   #240, paddle0Y 
   move.l   #0, paddle0d 

* Paddle 1 
   move.l   #635, paddle1X 
   move.l   #240, paddle1Y 
   move.l   #0, paddle1d 

* Scores 
   move.b   #0, score0 
   move.b   #0, score1 

* Enable double buffering 
   move.b   #92, D0 
   move.b   #17, D1 
   trap   #15 

gameLoop 
* draw stuff 
   bsr   drawCourt 
   bsr   drawBall 
   bsr   drawPaddle0 
   bsr   drawPaddle1 
   bsr   drawScore 

* pause for a bit and do input! 

   move.b   #8, D0   Get initial counter value 
   trap   #15 
   move.l   D1, D2   Move it into temp space 

pauseLoop   move.b   #7, D0 
   trap   #15 
   cmp.b   #0, D1 
   beq   faildown0 
   move.b   #5, D0 
   trap   #15  

   cmp.b   #'a', D1 
   bne   failup0 
   move.l  #-4, paddle0d 
failup0 
   cmp.b   #'z', D1 
   bne   faildown0 
   move.l  #4, paddle0d 
faildown0 
   cmp.b   #'k', D1 
   bne   failup1 
   move.l  #-4, paddle1d 
failup1 
   cmp.b   #'m', D1 
   bne   faildown1 
   move.l  #4, paddle1d 
faildown1 

   move.b   #8, D0   Get counter value 
   trap   #15 
   sub.l   D2, D1   Subtract inital value from it 
   cmp   #2, D1   Check if we have passed through 2/100ths of a second 
   blt   pauseLoop 

* position paddles and move 
   move.l   paddle0Y, D6 
   add.l   paddle0d, D6 
   move.l   D6, paddle0Y 

   move.l   paddle1Y, D6 
   add.l   paddle1d, D6 
   move.l   D6, paddle1Y 

* fix paddles to screen 
   move.l   paddle0Y, D6 
   sub.l   paddleSize, D6 
   cmp   #16, D6 
   bgt   paddle0nofix 
   move.l   #0, paddle0d 
paddle0nofix 
   move.l   paddle1Y, D6 
   sub.l   paddleSize, D6 
   cmp   #16, D6 
   bgt   paddle1nofix 
   move.l   #0, paddle1d 
paddle1nofix 

   move.l   paddle0Y, D6 
   add.l   paddleSize, D6 
   cmp   #480, D6 
   blt   paddle0nofix2 
   move.l   #0, paddle0d 
paddle0nofix2 
   move.l   paddle1Y, D6 
   add.l   paddleSize, D6 
   cmp   #480, D6 
   blt   paddle1nofix2 
   move.l   #0, paddle1d 
paddle1nofix2 

* position the ball and move it 
   move.l   ballX, D6 
   move.l   ballY, D7 
   add.l   deltaX, D6 
   add.l   deltaY, D7 
   move.l   D6, ballX 
   move.l   D7, ballY 

* check balls position and change delta accordingly 

   bsr   screenCollide 
   bsr   paddle0Collide 
   bsr   paddle1Collide 

   move.b   #94, D0 
   trap   #15 
    
   move.b   score0, D0 
   move.b   score1, D1 
   cmp.b    #3, D0 
   beq   gameEnd 
   cmp.b    #3, D1 
   beq   gameEnd 
    
   jmp   gameLoop    
gameEnd 

* erm, clear the screen and display if u win or not... 

   move.b   #80, D0   Change the pen colour 
   move.l   #BLACK, D1 
   trap   #15    

   move.b  #81, D0   Fill colour 
   move.l   #BLACK, D1 
   trap   #15 

   move.l   #0, D1 
   move.l   #0, D2 
   move.l   #640, D3 
   move.l   #480, D4 
   move.b   #87, D0 
   trap   #15 

   move.b   #80, D0   Change the pen colour 
   move.l   #BLUE, D1 
   trap   #15    

   move.b  #81, D0   Fill colour 
   move.l   #BLACK, D1 
   trap   #15 

   move.b   #11, D0 
   move.w   #$FF00,D1 
   trap   #15 

   move.b   score0, D0 
   move.b   score1, D1 
   cmp.b   D0, D1 
   bgt   player1 

    
player0   move   #14,d0   task number 14 (display null string) 
   lea   player0win,a1   address of string 
   trap   #15   display it 
   jmp   noplay 

player1   move   #14,d0   task number 14 (display null string) 
   lea   player1win,a1   address of string 
   trap   #15   display it 
   jmp   noplay 

noplay 
    
* The following 3D effect is hacky, please don't look at the code 
* too hard, it may cause eye damage. 

   move.l   #0, D7 
forloop0   move.l   #0, D6 
forloop1   move.b   #83, D0 
   move.l   D6, D1 
   move.l   D7, D2 
   trap   #15 
   move.l   D0, D1 
   move.b   #80, D0 
   trap   #15 
   move.l   D6, D1 
   move.l   D7, D2 
   lsl.l   #2, D1 
   lsl.l   #2, D2 
   add.l   #96, D1 
   add.l   #164, D2 
   move.l   D1, D3 
   move.l   D2, D4 
   add.l   #6, D3 
   add.l   #6, D4 
   move.b   #91, D0 
   trap   #15 
   add   #1, D6 
   cmp   #320, D6 
   blt   forloop1 
   add   #1, D7 
   cmp   #16, D7 
   blt   forloop0    
   move.b   #94, D0 
   trap   #15 

* Clear the text off... 
   move.b   #80, D0   Change the pen colour 
   move.l   #BLACK, D1 
   trap   #15    

   move.b  #81, D0   Fill colour 
   move.l   #BLACK, D1 
   trap   #15 

   move.l   #0, D1 
   move.l   #0, D2 
   move.l   #320, D3 
   move.l   #16, D4 

   move.b   #87, D0 
   trap   #15 

* Now to quit :-( 
   STOP   #$2000 
* =========== draw court subroutine ============ 
drawCourt 
   move.b   #80, D0   Change the pen colour 
   move.l   #BLACK, D1 
   trap   #15    

   move.b  #81, D0   Fill colour 
   move.l   #BLACK, D1 
   trap   #15 

   move.l   #0, D1 
   move.l   #0, D2 
   move.l   #640, D3 
   move.l   #480, D4 
   move.b   #87, D0 
   trap   #15 

   move.b   #80, D0   Change the pen colour 
   move.l   #GRAY, D1 
   trap   #15    

   move.b  #81, D0   Fill colour 
   move.l   #GRAY, D1 
   trap   #15 

   move.l   #319, D1   Center line 
   move.l   #0, D2 
   move.l   #321, D3 
   move.l   #480, D4 
   move.b   #87, D0 
   trap   #15 

   move.l   #0, D1   Center line 
   move.l   #15, D2 
   move.l   #640, D3 
   move.l   #16, D4 
   move.b   #87, D0 
   trap   #15 

   move.b   #80, D0   Change the pen colour 
   move.l   #GREEN, D1 
   trap   #15    

   move.b  #81, D0   Fill colour 
   move.l   #GREEN, D1 
   trap   #15 
   rts 

* =========== draw score subroutine ============ 
drawScore 

   move.b  #81, D0 
   move.l   #BLACK, D1 
   trap   #15 

* player 0 score 
   move.b   #11, D0 
   move.w   #$0500,D1 
   trap   #15 

   move.b   #15, D0 
   move.l   #0, D1 
   move.b   score0, D1 
   move.b   #10, D2 
   trap   #15 

* player 1 score 
   move.b   #11, D0 
   move.w   #$4900,D1 
   trap   #15 

   move.b   #15, D0 
   move.l   #0, D1 
   move.b   score1, D1 
   move.b   #10, D2 
   trap   #15 
    
   rts 

* =========== draw ball subroutine ============ 
drawBall   move.l   ballX, D6 
   move.l   ballY, D7 
   move.l   D6, D1   Move X 
   move.l   D6, D3   Move X 
   move.l   D7, D2   Move Y 
   move.l   D7, D4   Move Y 

   move.l   ballSize, D5   Give the ball a size 
   sub   D5, D1 
   sub   D5, D2    
   add   D5, D3 
   add   D5, D4 

   move.b   #88, D0   Draw a circle 
   trap   #15 

   rts 

* =========== draw paddle 0 subroutine ============ 
drawPaddle0 move.l   paddle0X, D6 
   move.l   paddle0Y, D7 
   move.l   D6, D1   Move X 
   move.l   D6, D3   Move X 
   move.l   D7, D2   Move Y 
   move.l   D7, D4   Move Y 

   move.l   ballSize, D5   Give the paddle a size 
   sub   D5, D1 
   add   D5, D3 

   move.l   paddleSize, D5   Give the paddle a size 
   sub   D5, D2    
   add   D5, D4 

   move.b   #87, D0   Draw a block 
   trap   #15 

   rts 

* =========== draw paddle 1 subroutine ============ 
drawPaddle1   move.l   paddle1X, D6 
   move.l   paddle1Y, D7 
   move.l   D6, D1   Move X 
   move.l   D6, D3   Move X 
   move.l   D7, D2   Move Y 
   move.l   D7, D4   Move Y 

   move.l   ballSize, D5   Give the paddle a size 
   sub   D5, D1 
   add   D5, D3 

   move.l   paddleSize, D5   Give the paddle a size 
   sub   D5, D2    
   add   D5, D4 

   move.b   #87, D0   Draw a block 
   trap   #15 

   rts 

* =========== collision with screen subroutine ============ 
screenCollide 
   cmp   #640, D6 
   bgt   scnballXRev0 
   cmp   #0, D6 
   blt   scnballXRev1 
   cmp   #480, D7 
   bgt   scnballYRev 
   cmp   #24, D7 
   blt   scnballYRev 
scnendY 
   rts 

* Player 0 scores! w00t! 
scnballXRev0 
   move.b   score0, D0 
   add.b   #1, D0 
   move.b   D0, score0 
   move.l   #320, ballX 
   move.l   #120, ballY 
   move.l   #-3, deltaX 
   move.l   #3, deltaY 
   rts      Why wait when someones already scored? 

* Player 1 scores! Hurrawr! 
scnballXRev1 
   move.b   score1, D0 
   add.b   #1, D0 
   move.b   D0, score1 
   move.l   #320, ballX 
   move.l   #120, ballY 
   move.l   #3, deltaX 
   move.l   #3, deltaY 
   rts      Why wait when someones already scored? 


scnballYRev   move.l   deltaY, D0 
   neg.l   D0 
   move.l   D0, deltaY 
   jmp scnendY 


* =========== paddle0 collision subroutine ============ 
paddle0Collide 
   move.l   ballX, D0 
   move.l   ballY, D1 
   move.l   paddle0X, D6 
   move.l   paddle0Y, D7 

* first off, are we actually like kinda within the y bounds 
   move.l   D7, D5    
   sub.l   paddleSize, D5   Paddle Y top 
   cmp   D5, D1   Compare ball Y with paddle Y 
   blt   failpaddle0   If its less than we fail 

   move.l   D7, D5    
   add.l   paddleSize, D5   Paddle Y bottom 
   cmp   D5, D1   Compare ball Y with paddle Y 
   bgt   failpaddle0   If its greater than we fail 

* if its greater than the right 
   add.l   ballSize, D6 
   cmp   D6, D0 
   bgt   failpaddle0 

* we are colliding! lets invert 
   jmp   pdBallXRev 
failpaddle0   rts 

* =========== paddle1 collision subroutine ============ 
paddle1Collide 
   move.l   ballX, D0 
   move.l   ballY, D1 
   move.l   paddle1X, D6 
   move.l   paddle1Y, D7 

* first off, are we actually like kinda within the y bounds 
   move.l   D7, D5    
   sub.l   paddleSize, D5   Paddle Y top 
   cmp   D5, D1   Compare ball Y with paddle Y 
   blt   failpaddle1   If its less than we fail 

   move.l   D7, D5    
   add.l   paddleSize, D5   Paddle Y bottom 
   cmp   D5, D1   Compare ball Y with paddle Y 
   bgt   failpaddle1   If its greater than we fail 

* if its less than the left 
   sub.l   ballSize, D6 
   cmp   D6, D0 
   blt   failpaddle1 

* we are colliding! lets invert 
   jmp   pdBallXRev 

failpaddle1   rts 

* =========== paddle collision response subishroutine ============ 
pdBallXRev   move.l   deltaX, D0 
   neg.l   D0 
   move.l   D0, deltaX 
   rts 

ballX   ds.l   1 
ballY   ds.l   1 
deltaX   ds.l   1 
deltaY   ds.l   1 
ballSize   ds.l   1 
paddleSize   ds.l   1 
paddle0X   ds.l   1 
paddle0Y   ds.l   1 
paddle0d   ds.l   1 
paddle1X   ds.l   1 
paddle1Y   ds.l   1 
paddle1d   ds.l   1 
score0   ds.b   1 
score1   ds.b   1 
player0win   dc.b   'Player 1 Wins!',0 
player1win   dc.b   'Player 2 Wins!',0 

   END   START
*~Font name~Courier New~
*~Font size~10~
*~Tab type~1~
*~Tab size~8~
